summaryrefslogtreecommitdiffstats
path: root/development
diff options
context:
space:
mode:
author Omer YILMAZ <mr1yh1@yahoo.com>2016-11-04 19:54:57 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2016-11-04 19:54:57 +0700
commitf857558fa04e8119a86c69c6d1591c7868c6b408 (patch)
tree908bedb5f2e95bc70d4eda2bf977ce4e10e136ba /development
parent60671019569dce950389657bce42d025519edd83 (diff)
downloadslackbuilds-f857558fa04e8119a86c69c6d1591c7868c6b408.tar.gz
slackbuilds-f857558fa04e8119a86c69c6d1591c7868c6b408.tar.xz
development/ccl: Added (Clozure Common Lisp).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/ccl/README22
-rw-r--r--development/ccl/ccl.SlackBuild104
-rw-r--r--development/ccl/ccl.info10
-rw-r--r--development/ccl/slack-desc19
-rw-r--r--development/ccl/sysctl.d/ccl.conf4
5 files changed, 159 insertions, 0 deletions
diff --git a/development/ccl/README b/development/ccl/README
new file mode 100644
index 0000000000..a7af48bb2f
--- /dev/null
+++ b/development/ccl/README
@@ -0,0 +1,22 @@
+This is a SlackBuild that will install ccl (Clozure Common Lisp).
+
+Ccl includes both 32-bit and 64-bit binaries (except ARM which is
+currently 32-bit only). Official scripts 'ccl' and 'ccl64' will be put
+on PATH, corresponding to the 32-bit and 64-bit lisp implementations
+in order. On Slackware64 with multilib installed, it's possible to
+run 32-bit ccl, using 'ccl' instead of 'ccl64'.
+
+Ccl uses low 16 bits of the address space for certain optimizations.
+The Linux kernel provides a feature that can prevent a process from
+mapping addresses below a certain base address to prevent exploitation
+of undiscovered null pointer dereference bugs in the kernel. To make
+ccl run on Slackware, 'mmap_min_addr' will be set to 4096. (see
+/etc/sysctl.d/ccl.conf)
+
+The 4K value will protect against certain (yet-to-be-discovered) NULL
+pointer deference bugs in the kernel, but will still allow
+applications to use low-memory addresses. For details see
+http://trac.clozure.com/ccl/wiki/PlatformNotes
+
+To make ccl usable before a reboot, execute the command below;
+# /sbin/sysctl vm.mmap_min_addr=4096 \ No newline at end of file
diff --git a/development/ccl/ccl.SlackBuild b/development/ccl/ccl.SlackBuild
new file mode 100644
index 0000000000..2c659047e7
--- /dev/null
+++ b/development/ccl/ccl.SlackBuild
@@ -0,0 +1,104 @@
+#!/bin/sh
+
+# Slackware build script for ccl (Clozure Common Lisp)
+
+# Copyright 2016 Omer YILMAZ <mr1yh1@yahoo.com>, Istanbul TURKEY.
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=ccl
+VERSION=${VERSION:-1.11}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM
+case "$ARCH" in
+ arm) tar xvf $CWD/$PRGNAM-$VERSION-linuxarm.tar.gz ;;
+ *) tar xvf $CWD/$PRGNAM-$VERSION-linuxx86.tar.gz ;;
+esac
+cd $PRGNAM
+
+# removing .svn directories
+set +e
+find . -iname .svn -exec rm -r '{}' 2> /dev/null \;
+set -e
+
+# setting permissions
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# installing to /usr
+CCL_DIR=$PKG/usr/$PRGNAM
+mkdir -p $CCL_DIR
+cp -a * $CCL_DIR
+
+# installing sysctl configuration file
+mkdir -p $PKG/etc/sysctl.d
+cat $CWD/sysctl.d/ccl.conf > $PKG/etc/sysctl.d/ccl.conf
+
+# changing CCL_DEFAULT_DIRECTORY in scripts and
+# putting them on the path
+mkdir -p $PKG/usr/bin
+cat scripts/ccl | \
+ sed 's#CCL_DEFAULT_DIRECTORY=/usr/local/src/ccl#CCL_DEFAULT_DIRECTORY=/usr/ccl#' \
+ > $PKG/usr/bin/ccl
+cat scripts/ccl64 | \
+ sed 's#CCL_DEFAULT_DIRECTORY=/usr/local/src/ccl#CCL_DEFAULT_DIRECTORY=/usr/ccl#' \
+ > $PKG/usr/bin/ccl64
+chmod +x $PKG/usr/bin/ccl
+chmod +x $PKG/usr/bin/ccl64
+
+# Strip binaries and libraries
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Manual ($CCL_DIR/doc/manual) is in lisp forms.
+# Generating various kinds of documentation possible/requires "ccldoc".
+# see http://trac.clozure.com/ccldoc
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a doc/LICENSE doc/LGPL doc/release-notes* $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/ccl/ccl.info b/development/ccl/ccl.info
new file mode 100644
index 0000000000..7bfbcd2c42
--- /dev/null
+++ b/development/ccl/ccl.info
@@ -0,0 +1,10 @@
+PRGNAM="ccl"
+VERSION="1.11"
+HOMEPAGE="http://ccl.clozure.com"
+DOWNLOAD="ftp://ftp.clozure.com/pub/release/1.11/ccl-1.11-linuxx86.tar.gz"
+MD5SUM="c02ddfc4bcc6ef073297d2d6971d20ea"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Omer YILMAZ"
+EMAIL="mr1yh1@yahoo.com"
diff --git a/development/ccl/slack-desc b/development/ccl/slack-desc
new file mode 100644
index 0000000000..1e21e55ca0
--- /dev/null
+++ b/development/ccl/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+ccl: ccl (Clozure Common Lisp).
+ccl:
+ccl: Clozure CL (often called CCL for short) is a free Common Lisp
+ccl: implementation with a long history. Some distinguishing features of
+ccl: the implementation include fast compilation speed, native threads, a
+ccl: precise, generational, compacting garbage collector, and a convenient
+ccl: foreign-function interface.
+ccl:
+ccl: For additional information :
+ccl: http://ccl.clozure.com
+ccl:
diff --git a/development/ccl/sysctl.d/ccl.conf b/development/ccl/sysctl.d/ccl.conf
new file mode 100644
index 0000000000..59ea1c1711
--- /dev/null
+++ b/development/ccl/sysctl.d/ccl.conf
@@ -0,0 +1,4 @@
+# required to avoid "remap spjump: Operation not permitted" error;
+# see the details in http://trac.clozure.com/ccl/wiki/PlatformNotes
+#
+vm.mmap_min_addr = 4096 \ No newline at end of file